condor_qsub(1)

Name

condor_qsubQueue jobs that use PBS/SGE-style submission

Synopsis
condor_qsub[ -- version]

condor_qsub[Specific options] [Directory options] [Environmental options] [File options] [Notification options] [Resource options] [Status options] [Submission options] commandfile

Description

condor_qsubsubmits an HTCondor job. This job is specified in a PBS/Torque style or an SGE style. condor_qsubpermits the submission of dependent jobs without the need to specify the full dependency graph at submission time. Doing things this way is neither as efficient as HTCondor's DAGMan, nor as functional as SGE's qsubor qalter. condor_qsubserves as a minimal translator to be able to use software originally written to interact with PBS, Torque, and SGE in an HTCondor pool.

condor_qsubattempts to behave like qsub. Less than half of the qsubfunctionality is implemented. Option descriptions describe the differences between the behavior of qsuband condor_qsub. qsuboptions not listed here are not supported. Some concepts present in PBS and SGE do not apply to HTCondor, and so these options are not implemented.

For a full listing of qsuboptions, please see

POSIX

    : http://pubs.opengroup.org/onlinepubs/9699919799/utilities/qsub.html

SGE

    : http://gridscheduler.sourceforge.net/htmlman/htmlman1/qsub.html

PBS/Torque

    : http://docs.adaptivecomputing.com/torque/4-1-3/Content/topics/commands/qsub.htm

condor_qsubaccepts either command line options or the single file, commandfile, that contains all of the commands.

condor_qsubdoes the opposite of job submission within the griduniverse batchgrid type, which takes HTCondor jobs submitted with HTCondor syntax and submits them to PBS, SGE, or LSF.

Options

-a date_time

    (Submission option) Specify a deferred execution date and time. The PBS/Torque syntax of date_timeis a string in the form [[[[CC]YY]MM]DD]hhmm[.SS]. The portions of this string which are optional are CC, YY, MM, DD, and SS. For SGE, MMand DDare notoptional. For PBS, MMand DDare optional. condor_qsubfollows the PBS style.

-A account_string

    (Status option) Uses group accounting where the string account_stringis the accounting group associated with this job. Unlike SGE, there is no default group of "sge".

-b y|n

    (Submission option) Using the SGE definition of its -boption, a value of ycauses condor_qsubto notparse the file for additional condor_qsubcommands. The default value is n. If the command line argument -f filenameis also specified, it negates a value of y.

-c checkpoint_option

    (Submission option) For standard universe jobs only, controls the how HTCondor produces checkpoints. checkpoint_optionsmay be one of

    n or N

    Do not produce checkpoints.

    s or S

    Do not produce periodic checkpoints. A job will only produce a checkpoint when the job is evicted.

    More options may be implemented in the future.

&mdash;condor-keep-files

    (Specific option) Directs HTCondor to notremove temporary files generated by condor_qsub, such as HTCondor submit files and sentinel jobs. These temporary files may be important for debugging.

-cwd

    (Directory option) Specifies the initial directory in which the job will run to be the current directory from which the job was submitted. This sets initialdirfor condor_submit.

-d pathor -wd path

    (Directory option) Specifies the initial directory in which the job will run to be path. This sets initialdirfor condor_submit.

-e filename

    (File option) Specifies the condor_submitcommand error, the file where stderris written. If not specified, set to the default name of <commandfile>.e<ClusterId>, where <commandfile>is the condor_qsubargument, and <ClusterId>is the job attribute ClusterIdassigned for the job.

&mdash;f qsub_file

    (Specific option) Parse qsub_fileto search for and set additional condor_submitcommands. Within the file, commands will appear as #PBSor #SGE. condor_qsubwill parse the batch file listed as qsub_file.

-h

    (Status option) Placed submitted job directly into the hold state.

&mdash;help

    (Specific option) Print usage information and exit.

-hold_jid <jid>

    (Status option) Submits a job in the hold state. This job is released only when a previously submitted job, identified by its cluster ID as <jid>, exits successfully. Successful completion is defined as not exiting with exit code 100. In implementation, there are three jobs that define this SGE feature. The first job is the previously submitted job. The second job is the newly submitted one that is waiting for the first to finish successfully. The third job is what SGE calls a sentineljob; this is an HTCondor local universe job that watches the history for the first job's exit code. This third job will exit once it has seen the exit code and, for a successful termination of the first job, run condor_releaseon the second job. If the first job is an array job, the second job will only be released after all individual jobs of the first job have completed.

-i [hostname:]filename

    (File option) Specifies the condor_submitcommand input, the file from which stdinis read.

-j characters

    (File option) Acceptable characters for this option are e, o, and n. The only sequence that is relevant is eo; it specifies that both standard output and standard error are to be sent to the same file. The file will be the one specified by the -ooption, if both the -oand -eoptions exist. The file will be the one specified by the -eoption, if only the -eoption is provided. If neither the -onor the -eoptions are provided, the file will be the default used for the -ooption.

-l resource_spec

    (Resource option) Specifies requirements for the job, such as the amount of RAM and the number of CPUs. Only PBS-style resource requests are supported. resource_specis a comma separated list of key/value pairs. Each pair is of the form resource_name=value. resource_nameand valuemay be

    resource_namevalueDescriptionarchstringSets Archmachine attribute. Enclose in double quotes.filesizeDisk space requested.hoststringHost machine on which the job must run.memsizeAmount of memory requested.nodes{<node_count> | <hostname>} [:ppn=<ppn>] [:gpus=<gpu>] [:<property> [:<property>] ...] [+ ...]Number and/or properties of nodes to be used. For examples, please see http://docs.adaptivecomputing.com/torque/4-1-3/Content/topics/2-jobs/requestingRes.htm#qsubopsysstringSets OpSysmachine attribute. Enclose in double quotes.procsintegerNumber of CPUs requested.A size value is an integer specified in bytes, following the PBS/Torque default. Append Kb, Mb, Gb, or Tbto specify the value in powers of two quantities greater than bytes.

-m a|e|n

    (Notification option) Identify when HTCondor sends notification e-mail. If a, send e-mail when the job terminates abnormally. If e, send e-mail when the job terminates. If n, never send e-mail.

-M e-mail_address

    (Notification option) Sets the destination address for HTCondor e-mail.

-o filename

    (File option) Specifies the condor_submitcommand output, the file where stdoutis written. If not specified, set to the default name of <commandfile>.o<ClusterId>, where <commandfile>is the condor_qsubargument, and <ClusterId>is the job attribute ClusterIdassigned for the job.

-p integer

    (Status option) Sets the prioritysubmit command for the job, with 0 being the default. Jobs with higher numerical priority will run before jobs with lower numerical priority.

&mdash;print

    (Specific option) Send to stdoutthe contents of the HTCondor submit description file that condor_qsubgenerates.

-r y|n

    (Status option) The default value of yimplements the default HTCondor policy of assuming that jobs that do not complete are placed back in the queue to be run again. When n, job submission is restricted to only running the job if the job ClassAd attribute NumJobStartsis currently 0. This identifies the job as not re-runnable, limiting it to start once.

-S shell

    (Submission option) Specifies the path and executable name of a shell. Alters the HTCondor submit description file produced, such that the executable becomes a wrapper script. Within the submit description file will be executable = <shell>and arguments = <commandfile>.

-t start [-stop:step]

    (Submission option) Queues a set of nearly identical jobs. The SGE-style syntax is supported. start, stop, and stepare all integers. startis the starting index of the jobs, stopis the ending index (inclusive) of the jobs, and stepis the step size through the indices. Note that using more than one processor or node in a job will not work with this option.

&mdash;test

    (Specific option) With the intention of testing a potential job submission, parse files and commands to generate error output. Produces, but then removes the HTCondor submit description file. Never submits the job, even if no errors are encountered.

-v variable list

    (Environmental option) Used to set the submit command environmentfor the job. variable listis as that defined for the submit command. Note that the syntax needed is specialized to deal with quote marks and white space characters.

-V

    (Environmental option) Sets getenv = Truein the submit description file.

-W attr_name=attr_value[,attr_name=attr_value...]

    (File option) PBS/Torque supports a number of attributes. However, condor_qsubonly supports the names stageinand stageoutfor attr_name. The format of attr_valuefor stageinand stageoutis local_file@hostname:remote_file[,...]and we strip it to remote_file[,...]. HTCondor's file transfer mechanism is then used if needed.

&mdash;version

    (Specific option) Print version information for the condor_qsubprogram and exit. Note that condor_qsubhas its own version numbers which are separate from those of HTCondor.

Exit Status

condor_qsubwill exit with a status value of 0 (zero) upon success, and it will exit with the value 1 (one) upon failure to submit a job.

Author
Center for High Throughput Computing, University of Wisconsin&ndash;Madison

Copyright
Copyright © 1990-2019 Center for High Throughput Computing, Computer Sciences Department, University of Wisconsin-Madison, Madison, WI. All Rights Reserved. Licensed under the Apache License, Version 2.0.